#include <stdio.h>
#include <math.h>
#include <allegro.h>

#define FSCREEN 0
#define VER "1.02"

int DX,DY,BG,TXTC,CL,CL1;
BITMAP *VSCR;
BITMAP *pan,*tit,*instr,*rec1r,*rec1y,*rec2r,*rec2y,*fagiolo,*ombra,*menu,*cursor;
BITMAP *smouse,*smouse1,*smouse2,*smouse3;
BITMAP *_1,*_2,*_3,*_5,*_7;
RGB pal_tit[256],pal_pan[256],pal_instr[256];
SAMPLE *put,*putok,*intro,*mazzuoro,*winr;
char name1[20],name2[20];
int PL,P[14],SCORE[6];
int fx[1000],fy[1000],fa[1000];
int MODE,LEVEL,BEANS;
bool posiziona,mousepress;

void init();
void title();
void initGame();
void instruction();
void option();
void nextMove();
void nextMoveCPU();
void move(int,int);
void ai(int *,int,int,int,int);
int tryMoveCPU(int *,int,int);
void panel();
void drawFagioli();
void rePaint(bool);
void wait(long);
void animation(int,int);
void thinking(int);
int getOpposite(int);
int decPos(int);
int incPos(int);
int max(int *);
bool isEndgame();
void winner();
int Random(int);
bool mousePos(int,int,int,int);

void init()
 {
  BG=2; TXTC=2; CL=16; CL1=1;
  DX=640; DY=480;
  MODE=1; LEVEL=1; BEANS=5;
  sprintf(name1,"Player 1");
  sprintf(name2,"Player 2");
  for(int i=0;i<1000;i++)
 	 {
 	  fx[i]=Random(50); fy[i]=Random(42); fa[i]=Random(360);
 	 }
  allegro_init();
  install_timer();
  install_keyboard();
  install_mouse();
  install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,NULL);
  VSCR=create_bitmap(DX,DY);
  set_color_depth(8);
  if(FSCREEN) { if(set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,DX,DY,0,0)==-1) { exit(0); } }
  else { if(set_gfx_mode(GFX_AUTODETECT_WINDOWED,DX,DY,0,0)==-1) { exit(0); } }
  pan=load_bitmap("data/mazzuoro.bmp",pal_pan);
  tit=load_bitmap("data/title.bmp",pal_tit);
  instr=load_bitmap("data/instr.bmp",pal_instr);
  smouse1=create_sub_bitmap(pan,952,234,48,53);
  smouse2=create_sub_bitmap(pan,957,289,40,50);
  smouse3=create_sub_bitmap(tit,908,0,48,53);
  smouse=smouse1;
  cursor=create_sub_bitmap(tit,658,0,43,36);
  menu=create_sub_bitmap(tit,702,211,182,215);
  _1=create_sub_bitmap(tit,729,0,32,50);
  _2=create_sub_bitmap(tit,789,0,38,50);
  _3=create_sub_bitmap(tit,853,0,39,50);
  _5=create_sub_bitmap(tit,726,65,41,50);
  _7=create_sub_bitmap(tit,786,65,38,50);
  rec1r=create_sub_bitmap(pan,819,0,90,90);
  rec1y=create_sub_bitmap(pan,910,0,90,90);
  rec2r=create_sub_bitmap(pan,799,91,101,101);
  rec2y=create_sub_bitmap(pan,900,91,101,101);
  fagiolo=create_sub_bitmap(pan,982,200,18,10);
  ombra=create_sub_bitmap(pan,982,218,18,10);
  put=load_wav("data/put.wav");
  putok=load_wav("data/putok.wav");
  intro=load_wav("data/intro.wav");
  mazzuoro=load_wav("data/mazzuoro.wav");
  winr=load_wav("data/winner.wav");
  set_palette(pal_tit);
 }

void initGame()
 {
  play_sample(intro,200,100,1000,0);
  panel();
  rePaint(false);
  fade_in(pal_pan,8);
  PL=2;
  for(int i=0;i<14;i++) { P[i]=BEANS; }
  P[6]=0; P[13]=0;
 }

void nextMove()
 {
 	int ypos,mpos;
 	
 	mpos=0;
 	smouse=smouse1;
  if(PL==1)
   {
    textprintf_ex(VSCR,font,312*2,30*2,TXTC,1,"<");
    textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"%s move! (1,2,3,4,5,6 or mouse)",name1);
    if(mousepress)
     {
      if(mousePos(26,26,88,88))  { masked_blit(rec1y,VSCR,0,0,25 ,25,DX,DY); mpos=1; smouse=smouse2; }
      if(mousePos(126,26,88,88)) { masked_blit(rec1y,VSCR,0,0,125,25,DX,DY); mpos=2; smouse=smouse2; }
      if(mousePos(226,26,88,88)) { masked_blit(rec1y,VSCR,0,0,225,25,DX,DY); mpos=3; smouse=smouse2; }
      if(mousePos(326,26,88,88)) { masked_blit(rec1y,VSCR,0,0,325,25,DX,DY); mpos=4; smouse=smouse2; }
      if(mousePos(426,26,88,88)) { masked_blit(rec1y,VSCR,0,0,425,25,DX,DY); mpos=5; smouse=smouse2; }
      if(mousePos(526,26,88,88)) { masked_blit(rec1y,VSCR,0,0,525,25,DX,DY); mpos=6; smouse=smouse2; }
     }
   }
  if(PL==2)
   {
    textprintf_ex(VSCR,font,7*2,138*2,TXTC,1,">");
    textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"%s move! (1,2,3,4,5,6 or mouse)",name2);
    if(mousepress)
     {
      if(mousePos(26,238,88,88))  { masked_blit(rec1y,VSCR,0,0,25 ,237,DX,DY); mpos=1; smouse=smouse2; }
      if(mousePos(126,238,88,88)) { masked_blit(rec1y,VSCR,0,0,125,237,DX,DY); mpos=2; smouse=smouse2; }
      if(mousePos(226,238,88,88)) { masked_blit(rec1y,VSCR,0,0,225,237,DX,DY); mpos=3; smouse=smouse2; }
      if(mousePos(326,238,88,88)) { masked_blit(rec1y,VSCR,0,0,325,237,DX,DY); mpos=4; smouse=smouse2; }
      if(mousePos(426,238,88,88)) { masked_blit(rec1y,VSCR,0,0,425,237,DX,DY); mpos=5; smouse=smouse2; }
      if(mousePos(526,238,88,88)) { masked_blit(rec1y,VSCR,0,0,525,237,DX,DY); mpos=6; smouse=smouse2; }
     }
   }
  mousepress=true;
  if((mouse_b & 1) && mpos!=0) move(mpos,PL);
  if(key[KEY_1]) { move(1,PL); clear_keybuf(); }
  if(key[KEY_2]) { move(2,PL); clear_keybuf(); }
  if(key[KEY_3]) { move(3,PL); clear_keybuf(); }
  if(key[KEY_4]) { move(4,PL); clear_keybuf(); }
  if(key[KEY_5]) { move(5,PL); clear_keybuf(); }
  if(key[KEY_6]) { move(6,PL); clear_keybuf(); }
 }

void move(int pos,int pl)
 {
  int s,i,n;

  if(pl==1)
   {
    s=6-pos; i=s+1; n=P[s];
    if(n==0) return;
    animation(s,s);
    P[s]=0;
    while(n>0)
     {
      if(i!=13) { n--; P[i]++; animation(i,s); }
      i=incPos(i);
     }
    i=decPos(i);
    if(i!=6) PL=2;
    if(P[i]==1 && i!=6 && i<=5)
     { play_sample(mazzuoro,200,100,1000,0); animation(getOpposite(i),i); P[6]+=P[i]; P[i]=0; P[6]+=P[getOpposite(i)]; P[getOpposite(i)]=0; animation(6,-1); }
   }
  if(pl==2)
   {
    s=pos+6; i=s+1; n=P[s];
    if(n==0) return;
    animation(s,s);
    P[s]=0;
    while(n>0)
     {
      if(i!=6) { n--; P[i]++; animation(i,s); }
      i=incPos(i);
     }
    i=decPos(i);
    if(i!=13) PL=1;
    if(P[i]==1 && i!=13 && i>=7)
     { play_sample(mazzuoro,200,100,1000,0); animation(getOpposite(i),i); P[13]+=P[i]; P[i]=0; P[13]+=P[getOpposite(i)]; P[getOpposite(i)]=0; animation(13,-1); }
   }
 }

void panel()
 {
  clear_to_color(VSCR,0);
  blit(pan,VSCR,0,0,0,0,DX,DY);
  drawFagioli();
  for(int i=0;i<6;i++) { textprintf_ex(VSCR,font,40+i*50*2,20*2,CL,-1,"%d",P[5-i]); }
  textprintf_ex(VSCR,font,20,134,CL1,-1,"%d",P[6]);
  for(int i=0;i<6;i++) { textprintf_ex(VSCR,font,40+i*50*2,127*2,CL,-1,"%d",P[i+7]); }
  textprintf_ex(VSCR,font,550,150,CL1,-1,"%d",P[13]);
 }

void drawFagioli()
 {
 	int xx,yy;

 	for(int i=0;i<6;i++)
 	 {
 	 	for(int j=0;j<P[5-i];j++)
 	 	 {
 	 	 	xx=40+i*100+fx[j+i]; yy=48+fy[j+i];
 	 	 	rotate_sprite(VSCR,ombra,xx+1,yy+1,fa[j+i]*65536);
 	 	 	rotate_sprite(VSCR,fagiolo,xx,yy,fa[j+i]*65536);
 	   }
   }
	for(int j=0;j<P[6];j++)
	 {
		xx=20+fx[j]; yy=142+fy[j];
   	rotate_sprite(VSCR,ombra,xx+1,yy+1,fa[j]*65536);
 	  rotate_sprite(VSCR,fagiolo,xx,yy,fa[j]*65536);
 	 }
 	for(int i=0;i<6;i++)
 	 {
 	 	for(int j=0;j<P[i+7];j++)
 	 	 {
 	 	 	xx=40+i*100+fx[j+i]; yy=262+fy[j+i];
 	 	 	rotate_sprite(VSCR,ombra,xx+1,yy+1,fa[j+i]*65536);
 	 	 	rotate_sprite(VSCR,fagiolo,xx,yy,fa[j+i]*65536);
 	   }
   }
	for(int j=0;j<P[13];j++)
	 {
		xx=550+fx[j]; yy=158+fy[j];
   	rotate_sprite(VSCR,ombra,xx+1,yy+1,fa[j]*65536);
 	  rotate_sprite(VSCR,fagiolo,xx,yy,fa[j]*65536);
 	 }   
 }

void rePaint(bool m)
 {
  if(m)
   {
    poll_mouse();
    masked_blit(smouse,VSCR,0,0,mouse_x-22,mouse_y,DX,DY);
   }
  blit(VSCR,screen,0,0,0,0,DX,DY);
  vsync();
 }

void animation(int pos, int s)
 {
  int x,y,x1,y1;

  if(pos==6 || pos==13) play_sample(putok,200,100,1000,0);
  else play_sample(put,200,100,1000,0);
  for(int i=0;i<50;i++)
   {
    panel();
    if(pos<=5)  { x=100*(5-pos)+25; y=25; }
    if(pos>5)   { x=100*(pos-7)+25; y=237; }
    if(pos==13) { x=536; y=132; masked_blit(rec2r,VSCR,0,0,x,y,DX,DY); }
    if(pos==6)  { x=5;   y=118; masked_blit(rec2r,VSCR,0,0,x,y,DX,DY); }
    if(pos!=6 && pos!=13) masked_blit(rec1r,VSCR,0,0,x,y,DX,DY);
    if(s!=-1)
     {
      if(s<=5)  { x1=100*(5-s)+25; y1=25; }
      if(s>5)   { x1=100*(s-7)+25; y1=237; }
      masked_blit(rec1y,VSCR,0,0,x1,y1,DX,DY);
     }
    rePaint(false);
   }
 }

void thinking(int an)
 {
  int x,y,r;

  x=299*2; y=204*2; r=8*2;
  for(int i=0;i<25;i++)
   {
    panel();
    circlefill(VSCR,x,y,r,CL);
    circle(VSCR,x,y,r,BG);
    line(VSCR,x,y,(int)(x+r*cos(an)),(int)(y+r*sin(an)),BG);
    textprintf_ex(VSCR,font,312*2,30*2,TXTC,1,"<");
    textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"Computer move! Thinking...");
    rePaint(false);
   }
 }

int getOpposite(int pos)
 {
  if(pos==0) return 12;
  if(pos==1) return 11;
  if(pos==2) return 10;
  if(pos==3) return 9;
  if(pos==4) return 8;
  if(pos==5) return 7;
  if(pos==7) return 5;
  if(pos==8) return 4;
  if(pos==9) return 3;
  if(pos==10) return 2;
  if(pos==11) return 1;
  if(pos==12) return 0;
 }

int decPos(int i)
 {
  if(i==0) return 13;
  return --i;
 }

int incPos(int i)
 {
  i++; i=i%14;
  return i;
 }

void nextMoveCPU()
 {
  int aux[14];
  int an,d;

  if(LEVEL==1) d=1; if(LEVEL==2) d=0;
  an=0;
  for(int i=0;i<6;i++) SCORE[i]=0;
  for(int i=0;i<6;i++)
   {
    thinking(an); an++;
    for(int j=0;j<14;j++) aux[j]=P[j];
    aux[6]=0; aux[13]=0;
    if(aux[i]==0) SCORE[i]=-10000; else ai(aux,6-i,i,PL,d);
   }

  printf("Score: "); for(int i=0;i<6;i++) printf("%d ",SCORE[i]); printf("\n");
  //while(!key[KEY_SPACE]);

  move(max(SCORE),PL);
 }

void ai(int *aux,int pos,int fpos,int pl,int d)
 {
  int aux2[14];

  pl=tryMoveCPU(aux,pos,pl);
  if(d==0)
   {
    if(pl==1) SCORE[fpos]+=aux[6]-aux[13]+5; else SCORE[fpos]+=aux[6]-aux[13];
    return;
   }
  for(int i=0;i<6;i++)
   {
    for(int j=0;j<14;j++) aux2[j]=aux[j];
    aux2[6]=0; aux2[13]=0;
    ai(aux2,6-i,fpos,pl,d-1);
   }
 }

int tryMoveCPU(int *aux,int pos,int pl)
 {
  int s,i,n,ppl;
  
  ppl=pl;
  if(pl==1)
   {
    s=6-pos;
    i=s+1;
    n=aux[s];
    aux[s]=0;
    if(n==0) return ppl;
    while(n>0)
     {
      if(i!=13) { n--; aux[i]++; }
      i=incPos(i);
     }
    i=decPos(i);
    if(i!=6) ppl=2;
    if(aux[i]==1 && i!=6 && i<=5)
     { aux[6]+=aux[i]; aux[i]=0; aux[6]+=aux[getOpposite(i)]; aux[getOpposite(i)]=0; }
   }
  if(pl==2)
   {
    s=pos+6;
    i=s+1;
    n=aux[s];
    aux[s]=0;
    if(n==0) return ppl;
    while(n>0)
     {
      if(i!=6) { n--; aux[i]++; }
      i=incPos(i);
     }
    i=decPos(i);
    if(i!=13) ppl=1;
    if(aux[i]==1 && i!=13 && i>=7)
     { aux[13]+=aux[i]; aux[i]=0; aux[13]+=aux[getOpposite(i)]; aux[getOpposite(i)]=0; }
   }
  return ppl;
 }

int max(int *sc)
 {
  int m;

  m=0;
  for(int i=1;i<6;i++) if(sc[i]>sc[m]) m=i;
  return 6-m;
 }

bool isEndgame()
 {
  int t1,t2;

  t1=0; t2=0;
  for(int i=0;i<6;i++) { t1+=P[i]; t2+=P[7+i]; }
  if(t1==0 || t2==0) return true;
  return false;
 }

void winner()
 {
  for(int i=0;i<6;i++) { P[6]+=P[i]; P[13]+=P[7+i]; P[i]=0; P[7+i]=0; }

  play_sample(winr,200,100,1000,0);
  for(int i=0;i<500;i++)
   {
    panel();
    if(P[6]>P[13])
     {
      if(MODE==2) textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"*** %s WIN!!!! ***",name1);
      else textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"*** COMPUTER WIN!!!! ***");
     }
    if(P[6]<P[13])
     {
      textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"*** %s WIN!!!! ***",name2);
     }
    if(P[6]==P[13])
     {
      textprintf_ex(VSCR,font,10*2,196*2,TXTC,1,"*** DRAW!!!! ***");
     }
    rePaint(true);
   }
 }

void title()
 {
 	int pos,start;

  smouse=smouse3;
 	pos=0; start=0;
  blit(tit,VSCR,0,0,0,0,DX,DY);
  rePaint(false);
  fade_in(pal_tit,2);
  set_keyboard_rate(5000,1000);
  while(!start)
   {
    blit(tit,VSCR,0,0,0,0,DX,DY);
    blit(cursor,VSCR,0,0,391,218+53*pos,DX,DY);
    textprintf_ex(VSCR,font,605,130,19,1,"%s",VER);
    rePaint(true);
    if(key[KEY_DOWN]) { pos++; play_sample(put,200,100,1000,0); key[KEY_DOWN]=false; }
    if(key[KEY_UP])   { pos--; play_sample(put,200,100,1000,0); key[KEY_UP]=false; }
    pos=pos%4; if(pos<0) pos=3;
    if(mousePos(433,216,152,40) && pos!=0) { pos=0; play_sample(put,200,100,1000,0); }
    if(mousePos(433,268,113,40) && pos!=1) { pos=1; play_sample(put,200,100,1000,0); }
    if(mousePos(433,323,169,40) && pos!=2) { pos=2; play_sample(put,200,100,1000,0); }
    if(mousePos(433,373,63,40)  && pos!=3) { pos=3; play_sample(put,200,100,1000,0); }
    if(key[KEY_SPACE] || (mouse_b & 1))
     {
     	if(pos==0) { start=1; }
     	if(pos==1) { option(); }
     	if(pos==2) { instruction(); }
      if(pos==3) { fade_out(8); exit(0); }
     }
    if(key[KEY_ESC]) { fade_out(8); exit(0); }
   }
  mousepress=false;
  fade_out(8);
 }

int Random(int max) // Ritorna un numero pseudocasuale da 0 a max (max compreso)
 {
  max++;
  return(rand()%max);
 }

void instruction()
 {
 	fade_out(8);
 	blit(instr,VSCR,0,0,0,0,DX,DY);
  rePaint(false);
 	fade_in(pal_instr,8);
  while(!key[KEY_ESC]) { }
  clear_keybuf();
  fade_out(8);
  blit(tit,VSCR,0,0,0,0,DX,DY);
  rePaint(false);
  fade_in(pal_tit,8);
 }

void option()
 {
  int pos,prev;
 	
  fade_out(8);
  pos=0; prev=0;
  blit(tit,VSCR,0,0,0,0,DX,DY);
  blit(menu,VSCR,0,0,432,212,DX,DY);
  rePaint(false);
  fade_in(pal_tit,8);
  bool mpress=true;
  while(!prev)
   {
    blit(tit,VSCR,0,0,0,0,DX,DY);
    blit(menu,VSCR,0,0,432,212,DX,DY);
    blit(cursor,VSCR,0,0,393,218+53*pos,DX,DY);
    textprintf_ex(VSCR,font,605,130,19,1,"%s",VER);
    if(MODE==1) blit(_1,VSCR,0,0,550,217,DX,DY);  else blit(_2,VSCR,0,0,550,217,DX,DY);
    if(LEVEL==1) blit(_1,VSCR,0,0,530,268,DX,DY); else blit(_2,VSCR,0,0,530,268,DX,DY);
    if(BEANS==3) blit(_3,VSCR,0,0,550,324,DX,DY);
    if(BEANS==5) blit(_5,VSCR,0,0,550,324,DX,DY);
    if(BEANS==7) blit(_7,VSCR,0,0,550,324,DX,DY);
    rePaint(true);
    if(key[KEY_DOWN]) { pos++; play_sample(put,200,100,1000,0); key[KEY_DOWN]=false; }
    if(key[KEY_UP])   { pos--; play_sample(put,200,100,1000,0); key[KEY_UP]=false; }
    pos=pos%4; if(pos<0) pos=3;
    if(!(mouse_b & 1)) mpress=true;
    if(mousePos(433,216,152,40) && pos!=0) { pos=0; play_sample(put,200,100,1000,0); }
    if(mousePos(433,268,123,40) && pos!=1) { pos=1; play_sample(put,200,100,1000,0); }
    if(mousePos(433,323,142,40) && pos!=2) { pos=2; play_sample(put,200,100,1000,0); }
    if(mousePos(433,373,169,40) && pos!=3) { pos=3; play_sample(put,200,100,1000,0); }
    if(key[KEY_V]) play_sample(mazzuoro,200,100,1000,0);
    if(key[KEY_SPACE] || (mouse_b & 1) && mpress)
     {
     	key[KEY_SPACE]=false;
     	mpress=false;
     	if(pos==0) { play_sample(put,200,100,1000,0); if(MODE==1) MODE=2; else MODE=1; }
     	if(pos==1) { play_sample(put,200,100,1000,0); if(LEVEL==1) LEVEL=2; else LEVEL=1; }
     	if(pos==2)
     	 {
     	 	play_sample(put,200,100,1000,0);
     		switch(BEANS)
     		 {
     		  case 3: { BEANS=5; break; }
     		  case 5: { BEANS=7; break; }
     		  case 7: { BEANS=3; break; }
     		 }
     	 }
      if(pos==3) prev=1;
     }
    if(key[KEY_ESC]) prev=1;
   }
  fade_out(8);
  blit(tit,VSCR,0,0,0,0,DX,DY);
  rePaint(false);
  fade_in(pal_tit,8);
 }

bool mousePos(int x1, int y1, int w, int h)
 {
 	int x2,y2;
 	
 	x2=x1+w; y2=y1+h;
 	if(mouse_x>x1 && mouse_x<x2 && mouse_y>y1 && mouse_y<y2) return true;
 	else return false;
 }
